package observer;
/*
Copyright (c) Xerox Corporation 1998-2002.  All rights reserved.

Use and copying of this software and preparation of derivative works based
upon this software are permitted.  Any distribution of this software or
derivative works must comply with all applicable United States export control
laws.

This software is made available AS IS, and Xerox Corporation makes no warranty
about the software, its performance or its conformity to any specification.
*/



import java.util.Vector;


aspect SubjectObserverProtocolImpl extends SubjectObserverProtocol {

	declare parents: noCmd implements Subject;
    public Object noCmd.getData() { return this; }
    

    declare parents: PrintStatus implements Observer;
    public void PrintStatus.update() {
        noCmd observer = (noCmd)this.getSubject().getData();
        this.colorIdx = observer.colorIdx;
        showColor();
    }

    pointcut stateChanges(Subject s):
        target(s) &&
        (call(void noCmd.clearSelected()) || 
         call(void noCmd.redClicked()) ||
         call(void noCmd.yellowClicked()) ||
         call(void noCmd.blueClicked()));

}
